﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using HeuristicLab.Analysis;
using HeuristicLab.Core;
using HeuristicLab.Data;

namespace HeuristicLab.DataPreprocessing {
  public interface IChartLogic {

    List<DataRow> CreateAllDataRows( DataRowVisualProperties.DataRowChartType chartType);

    event DataPreprocessingChangedEventHandler Changed;

    event EventHandler SelectionChanged;

    ICheckedItemList<StringValue> CreateVariableItemList();

    List<DataRow> CreateAllSelectedDataRows(DataRowVisualProperties.DataRowChartType chartType);

    DataRow CreateSelectedDataRow(string variableName, DataRowVisualProperties.DataRowChartType chartType);

    DataRow CreateDataRow(string variableName,DataRowVisualProperties.DataRowChartType chartType);

    DataRow CreateDataRowRange(string variableName, int start, int end, DataRowVisualProperties.DataRowChartType chartType);

    ScatterPlot CreateScatterPlot(string variableNameX,string variableNameY);

    string GetVariableNameByIndex(int index);

    IEnumerable<string> GetVariableNames();
    IEnumerable<string> GetVariableNamesForHistogramClassification();

    IEnumerable<double> GetVariableValues(string variableName);
  }
}
